Index: /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/XMLStreamWriterHelper.java
===================================================================
--- /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/XMLStreamWriterHelper.java	(revision 5545)
+++ /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/XMLStreamWriterHelper.java	(revision 5546)
@@ -8,10 +8,10 @@
  * This class provides several helper methods for writing records in the
  * CLARIN-FCS record schema. These methods <em>do not</em> cover the full
- * spectrum of all variations of records that are permitted by the CLARIN FCS
+ * spectrum of all variations of records that are permitted by the CLARIN-FCS
  * specification.
  *
  * @see <a
- *      href="https://trac.clarin.eu/wiki/FCS-specification#SearchRetrieveOperation">
- *      CLARIN FCS specification, section "SearchRetrieve Operation"</a>
+ *      href="https://trac.clarin.eu/wiki/FCS/Specification">
+ *      CLARIN FCS specification, section "Operation searchRetrieve"</a>
  */
 public final class XMLStreamWriterHelper {
@@ -23,4 +23,9 @@
     private static final String FCS_KWIC_MIMETYPE =
             "application/x-clarin-fcs-kwic+xml";
+    private static final String FCS_HITS_NS =
+            "http://clarin.eu/fcs/dataview/hits";
+    private static final String FCS_HITS_PREFIX = "hits";
+    private static final String FCS_HITS_MIMETYPE =
+            "application/x-clarin-fcs-hits+xml";
 
 
@@ -205,9 +210,14 @@
      * @throws XMLStreamException
      *             if an error occurred
-     */
+     * @deprecated The the HITS data view instead.
+     */
+    @Deprecated
     public static void writeKWICDataView(XMLStreamWriter writer, String left,
             String keyword, String right) throws XMLStreamException {
         if (writer == null) {
             throw new NullPointerException("writer == null");
+        }
+        if (keyword == null) {
+            throw new NullPointerException("keyword == null");
         }
 
@@ -246,4 +256,5 @@
      * Convince method for writing a record with a KWIC data view. The following
      * code (arguments omitted) would accomplish the same result:
+     *
      * <pre>
      * ...
@@ -272,5 +283,7 @@
      * @throws XMLStreamException
      *             if an error occurred
-     */
+     * @deprecated The the HITS data view instead.
+     */
+    @Deprecated
     public static void writeResourceWithKWICDataView(XMLStreamWriter writer,
             String pid, String ref, String left, String keyword, String right)
@@ -285,3 +298,233 @@
     }
 
+
+
+    /**
+     * Convince method to write a simple HITS data view. It automatically
+     * performs the calls to
+     * {@link #writeStartDataView(XMLStreamWriter, String)} and
+     * {@link #writeEndDataView(XMLStreamWriter)}.
+     *
+     * @param writer
+     *            the {@link XMLStreamWriter} to be used
+     * @param left
+     *            the left context of the hit or <code>null</code> if not
+     *            applicable
+     * @param hit
+     *            the actual hit, that will be highlighted
+     * @param right
+     *            the right context of the hit or <code>null</code> if not
+     *            applicable
+     * @throws XMLStreamException
+     *             if an error occurred
+     */
+    public static void writeHitsDataView(XMLStreamWriter writer, String left,
+            String hit, String right) throws XMLStreamException {
+        if (writer == null) {
+            throw new NullPointerException("writer == null");
+        }
+        if (hit == null) {
+            throw new NullPointerException("hit == null");
+        }
+
+        writeStartDataView(writer, FCS_HITS_MIMETYPE);
+
+        // actual "hits" data view
+        writer.setPrefix(FCS_HITS_PREFIX, FCS_HITS_NS);
+        writer.writeStartElement(FCS_HITS_NS, "Result");
+        writer.writeNamespace(FCS_HITS_PREFIX, FCS_HITS_NS);
+
+        if ((left != null) && !left.isEmpty()) {
+            writer.writeCharacters(left);
+        }
+
+        writer.writeStartElement(FCS_HITS_NS, "Hit");
+        writer.writeCharacters(hit);
+        writer.writeEndElement(); // "Hit" element
+
+        if ((right != null) && !right.isEmpty()) {
+            writer.writeCharacters(right);
+        }
+
+        writer.writeEndElement(); // "Result" element
+
+        writeEndDataView(writer);
+    }
+
+
+    /**
+     * Convince method for writing a record with a KWIC data view. The following
+     * code (arguments omitted) would accomplish the same result:
+     *
+     * <pre>
+     * ...
+     * writeStartResource(...);
+     * writeHitsDataView(...);
+     * writeEndResource(...);
+     * ...
+     * </pre>
+     *
+     * @param writer
+     *            the {@link XMLStreamWriter} to be used
+     * @param pid
+     *            the persistent identifier of this resource or
+     *            <code>null</code>, if not applicable
+     * @param ref
+     *            the reference of this resource or <code>null</code>, if not
+     *            applicable
+     * @param left
+     *            the left context of the hit or <code>null</code> if not
+     *            applicable
+     * @param hit
+     *            the actual hit, that will be highlighted
+     * @param right
+     *            the right context of the hit or <code>null</code> if not
+     *            applicable
+     * @throws XMLStreamException
+     *             if an error occurred
+     */
+    public static void writeResourceWithHitsDataView(XMLStreamWriter writer,
+            String pid, String ref, String left, String hit, String right)
+            throws XMLStreamException {
+        if (writer == null) {
+            throw new NullPointerException("writer == null");
+        }
+
+        writeStartResource(writer, pid, ref);
+        writeHitsDataView(writer, left, hit, right);
+        writeEndResource(writer);
+    }
+
+
+    /**
+     * Convince method to write a simple HITS data view. It automatically
+     * performs the calls to
+     * {@link #writeStartDataView(XMLStreamWriter, String)} and
+     * {@link #writeEndDataView(XMLStreamWriter)}.
+     *
+     * @param writer
+     *            the {@link XMLStreamWriter} to be used
+     * @param text
+     *            the text content of the hit
+     * @param hits
+     *            an even-element array containing tuples for the hit markers in
+     *            the text content
+     * @param secondIsLength
+     *            if <code>true</code> the second element of each tuple in this
+     *            <code>hits</code> array is interpreted as an length; if
+     *            <code>false</code> it is interpreted as an end-offset
+     * @throws XMLStreamException
+     *             if an error occurred
+     */
+    public static void writeHitsDataView(XMLStreamWriter writer, String text,
+            int[] hits, boolean secondIsLength) throws XMLStreamException {
+        if (writer == null) {
+            throw new NullPointerException("writer == null");
+        }
+        if (text == null) {
+            throw new NullPointerException("text == null");
+        }
+        if (hits == null) {
+            throw new NullPointerException("text == null");
+        }
+        if ((hits.length == 0) || ((hits.length % 2) != 0)) {
+            throw new NullPointerException("length of hits array must " +
+                    "contain an even number of elements");
+        }
+
+        writeStartDataView(writer, FCS_HITS_MIMETYPE);
+
+        // actual "hits" data view
+        writer.setPrefix(FCS_HITS_PREFIX, FCS_HITS_NS);
+        writer.writeStartElement(FCS_HITS_NS, "Result");
+        writer.writeNamespace(FCS_HITS_PREFIX, FCS_HITS_NS);
+
+        int pos = 0;
+        for (int i = 0; i < hits.length; i += 2) {
+            int start  = hits[i];
+            int end    = hits[i + 1];
+
+            if ((start < 0) && (start > text.length())) {
+                throw new IllegalArgumentException("start index out of " +
+                        "bounds: start=" + start);
+            }
+            if (secondIsLength) {
+                if (end < 1) {
+                    throw new IllegalArgumentException(
+                            "length must be larger than 0: length = " + end);
+                }
+                end += start;
+            }
+            if (start >= end) {
+                throw new IllegalArgumentException("end offset must be " +
+                        "larger then start offset: start=" + start +
+                        ", end="+ end);
+            }
+
+            if (start > pos) {
+                String s = text.substring(pos, start);
+                writer.writeCharacters(s);
+            }
+            writer.writeStartElement(FCS_HITS_NS, "Hit");
+            writer.writeCharacters(text.substring(start, end));
+            writer.writeEndElement(); // "Hits" element
+            pos = end;
+        }
+        if (pos < text.length() - 1) {
+            writer.writeCharacters(text.substring(pos));
+        }
+
+        writer.writeEndElement(); // "Result" element
+
+        writeEndDataView(writer);
+    }
+
+
+    /**
+     * Convince method to write a simple HITS data view. It automatically
+     * performs the calls to
+     * {@link #writeStartDataView(XMLStreamWriter, String)} and
+     * {@link #writeEndDataView(XMLStreamWriter)}.
+     *
+     * <pre>
+     * ...
+     * writeStartResource(...);
+     * writeHitsDataView(...);
+     * writeEndResource(...);
+     * ...
+     * </pre>
+     *
+     * @param writer
+     *            the {@link XMLStreamWriter} to be used
+     * @param pid
+     *            the persistent identifier of this resource or
+     *            <code>null</code>, if not applicable
+     * @param ref
+     *            the reference of this resource or <code>null</code>, if not
+     *            applicable
+     * @param text
+     *            the text content of the hit
+     * @param hits
+     *            an even-element array containing tuples for the hit markers in
+     *            the text content
+     * @param secondIsLength
+     *            if <code>true</code> the second element of each tuple in this
+     *            <code>hits</code> array is interpreted as an length; if
+     *            <code>false</code> it is interpreted as an end-offset
+     * @throws XMLStreamException
+     *             if an error occurred
+     */
+    public static void writeResourceWithHitsDataView(XMLStreamWriter writer,
+            String pid, String ref, String text,
+            int[] hits, boolean secondIsLength)
+            throws XMLStreamException {
+        if (writer == null) {
+            throw new NullPointerException("writer == null");
+        }
+
+        writeStartResource(writer, pid, ref);
+        writeHitsDataView(writer, text, hits, secondIsLength);
+        writeEndResource(writer);
+    }
+
 } // class XMLStreamWriterHelper
Index: /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/utils/AbstractEndpointDescriptionBase.java
===================================================================
--- /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/utils/AbstractEndpointDescriptionBase.java	(revision 5546)
+++ /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/utils/AbstractEndpointDescriptionBase.java	(revision 5546)
@@ -0,0 +1,62 @@
+package eu.clarin.sru.server.fcs.utils;
+
+import java.net.URI;
+import java.util.Collections;
+import java.util.List;
+
+import eu.clarin.sru.server.fcs.DataView;
+import eu.clarin.sru.server.fcs.EndpointDescription;
+
+
+/**
+ * An abstract base class for implementing endpoint descriptions. It already
+ * implements the methods required for capabilities and supported dataviews.
+ *
+ * @see EndpointDescription
+ *
+ */
+public abstract class AbstractEndpointDescriptionBase implements EndpointDescription {
+    protected final List<URI> capabilities;
+    protected final List<DataView> supportedDataViews;
+
+    /**
+     * Constructor.
+     *
+     * @param capabilities
+     *            a list of capabilities supported by this endpoint
+     * @param supportedDataViews
+     *            a list of data views that are supported by this endpoint
+     */
+    protected AbstractEndpointDescriptionBase(List<URI> capabilities,
+            List<DataView> supportedDataViews) {
+        if (capabilities == null) {
+            throw new NullPointerException("capabilities == null");
+        }
+        if (capabilities.isEmpty()) {
+            throw new IllegalArgumentException("capabilities are empty");
+        }
+        this.capabilities = Collections.unmodifiableList(capabilities);
+
+        if (supportedDataViews == null) {
+            throw new NullPointerException("supportedDataViews == null");
+        }
+        if (supportedDataViews.isEmpty()) {
+            throw new IllegalArgumentException("supportedDataViews are empty");
+        }
+        this.supportedDataViews =
+                Collections.unmodifiableList(supportedDataViews);
+    }
+
+
+    @Override
+    public List<URI> getCapabilities() {
+        return capabilities;
+    }
+
+
+    @Override
+    public List<DataView> getSupportedDataViews() {
+        return supportedDataViews;
+    }
+
+} // abstract class EndpointDescriptionBase
Index: /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/utils/SimpleEndpointDescription.java
===================================================================
--- /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/utils/SimpleEndpointDescription.java	(revision 5546)
+++ /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/utils/SimpleEndpointDescription.java	(revision 5546)
@@ -0,0 +1,106 @@
+package eu.clarin.sru.server.fcs.utils;
+
+import java.net.URI;
+import java.util.Collections;
+import java.util.List;
+
+import eu.clarin.sru.server.SRUException;
+import eu.clarin.sru.server.fcs.DataView;
+import eu.clarin.sru.server.fcs.EndpointDescription;
+import eu.clarin.sru.server.fcs.ResourceInfo;
+
+
+/**
+ * A very simple implementation of an endpoint description that is initialized
+ * from static information supplied at construction time. Mostly used together
+ * with {@link SimpleEndpointDescriptionParser}, but it is agnostic how the
+ * static list of resource info records is generated.
+ *
+ * @see EndpointDescription
+ * @see SimpleEndpointDescriptionParser
+ */
+public class SimpleEndpointDescription extends AbstractEndpointDescriptionBase {
+    private final boolean pidCaseSensitive;
+    private final List<ResourceInfo> entries;
+
+
+    /**
+     * Constructor.
+     *
+     * @param capabilities
+     *            a list of capabilities supported by this endpoint
+     * @param supportedDataViews
+     *            a list of data views that are supported by this endpoint
+     * @param resources
+     *            a static list of resource info records
+     * @param pidCaseSensitive
+     *            <code>true</code> if comparison of persistent identifiers
+     *            should be performed case-sensitive, <code>false</code>
+     *            otherwise
+     */
+    public SimpleEndpointDescription(List<URI> capabilities,
+            List<DataView> supportedDataViews, List<ResourceInfo> resources,
+            boolean pidCaseSensitive) {
+        super(capabilities, supportedDataViews);
+
+        if (resources == null) {
+            throw new NullPointerException("entries == null");
+        }
+        this.entries = Collections.unmodifiableList(resources);
+        this.pidCaseSensitive = pidCaseSensitive;
+    }
+
+
+    @Override
+    public void destroy() {
+    }
+
+
+    @Override
+    public List<ResourceInfo> getResourceList(String pid) throws SRUException {
+        if (pid == null) {
+            throw new NullPointerException("pid == null");
+        }
+        if (pid.isEmpty()) {
+            throw new IllegalArgumentException("pid is empty");
+        }
+        if (!pidCaseSensitive) {
+            pid = pid.toLowerCase();
+        }
+        if (pid.equals(PID_ROOT)) {
+            return entries;
+        } else {
+            ResourceInfo ri = findRecursive(entries, pid);
+            if (ri != null) {
+                return ri.getSubResources();
+            }
+        }
+        return null;
+    }
+
+
+    private ResourceInfo findRecursive(List<ResourceInfo> items, String pid) {
+        if ((items != null) && !items.isEmpty()) {
+            for (ResourceInfo item : items) {
+                if (pidCaseSensitive) {
+                    if (pid.equals(item.getPid())) {
+                        return item;
+                    }
+                } else {
+                    if (pid.equalsIgnoreCase(item.getPid())) {
+                        return item;
+                    }
+                }
+                if (item.hasSubResources()) {
+                    ResourceInfo ri =
+                            findRecursive(item.getSubResources(), pid);
+                    if (ri != null) {
+                        return ri;
+                    }
+                }
+            } // for
+        }
+        return null;
+    }
+
+} // class SimpleEndpointDescription
